imgui = require 'imgui'

function love.load()    
    imgui.init()
    initPayload()  -- for mutable widgets
    love.graphics.setBackgroundColor(.6,.6,.6)
    --IMPORTANT: Widgets like Progress Bar need to be updated at every frame
    --The default optimization can hinder in the process
    imgui.noOptimize()
    --You can try removing this to see what happens?
end


function love.draw()
    drawLabel()
    drawProgressBar()
    drawScaler()
    drawSlider()
    drawRadioButtons()
    drawButtonWithTooltip()
    drawImage()
    imgui.stepper(stepper,400,300,200)
    imgui.draw()
end

function drawRadioButtons()
    imgui.layout.setCursor(20,400)
    imgui.layout.setColumns(1)
	imgui.radioButton(radioButton1,'I am radio button #1 (group 1)')
	imgui.radioButton(radioButton2,'I am radio button #2 (group 1)')
	imgui.radioButton(radioButton3,'I am radio button #3 (group 1)')

	imgui.layout.setPosition(0,20,true)
	imgui.radioButton(radioButton4,'I am radio button #4 (group 2)')
	imgui.radioButton(radioButton5,'I am radio button #5 (group 2)')
end

function drawProgressBar()
    imgui.progressBar(progress,250)
	imgui.layout.setColumns(2)
	if imgui.button(stopped and "Resume" or "Stop",100,48) then
		if imgui.isMouseReleased() then --execute this block only once!!
			stopped=not stopped
			if stopped then
				progress.update=function() return 0 end
			else
				progress.update=function(dt) return dt/5 end --5s delay
			end
		end
	end
	if imgui.button("Restart") then
		progress.value=0
	end
end

function drawScaler()
    imgui.layout.setCursor(200,200)
	imgui.layout.setColumns(4)
	imgui.tooltip('I am a Top-to-Bottom Scaler')
	imgui.scaler(scaler1,100)
	imgui.tooltip('I am a Bottom-to-Top Scaler')
	imgui.scaler(scaler2,100)
	imgui.tooltip('I go from Left-to-Right')
	imgui.scaler(scaler3,100)
	imgui.tooltip('I am completely normal!')
	imgui.scaler(scaler4,100)
end

function drawSlider()
    imgui.layout.setColumns(2)
	imgui.layout.setCursor(500,100)
	imgui.slider(slider,100)
	if progress[1] then
		imgui.progressBar(slider,100,25)
	else
		imgui.scaler(slider,100)
	end
	if imgui.checkBox(layoutTest,'Layout Test') then
		slider.vertical=not slider.vertical
	end
	if imgui.checkBox(progress,'Progress') then
		-- slider.vertical=not slider.vertical
	end
end

function love.textinput(text)
    imgui.textinput(text)
end

function initPayload()
    slider={value=0,vertical=true}
    layoutTest,progress={},{}
    stepper={list={"Thing One","Thing Two","Thing Three","Thing Four"}}
    progress={}
    scaler1={orientation='t-b'}
    scaler2={orientation='b-t'}
    scaler3={orientation='l-r'}
    scaler4={} --same as orientation set to 'l-r'

    group1,group2={},{}
    radioButton1={active=true,group=group1}
    radioButton2={group=group1}
    radioButton3={group=group1}
    radioButton4={group=group2}
    radioButton5={group=group2} -->try doing group=nil!
    group1[1],group1[2],group1[3]=radioButton1,radioButton2,radioButton3
    group2[1],group2[2]=radioButton4,radioButton5
    input={limit=11}
    imageButton={
        hover={.8,.8,.8},
        active={.4,.4,.4},
        image=love.graphics.newImage('button.png')
    }
    label={
        text="I am a Label!!",
        font=love.graphics.newFont("Kenney Mini Square.ttf",60)
    }
end

function drawButtonWithTooltip()
    imgui.tooltip('I am a tooltip!!!')
	if imgui.button('hello world','.8','center',100,100) then
		if imgui.btnReleased then
			print('working')
		end
	end
end

function drawImage()
    imgui.image('character.png','center','bottom',200,200)
    if imgui.imageButton(imageButton,'.8','.8',100,100) then
        imgui.label("You are clicking on an image-button!!",'.8','.93')
    end
end

function drawLabel()
    imgui.label(label,300,150)
end